package at.fhb.iti.algodat.ue2.bankomat.model;

import at.fhb.iti.algodat.ue2.bankomat.grafics.BankomatView;

import static at.fhb.iti.algodat.ue2.bankomat.model.BankomatState.*;

public class BankomatModelImplementation implements BankomatModel {

	// diverse Strings initialisieren -> knnen spter in andere Sprachen bersetzt werden

	final String GELDEINGABETEXT="Bitte gewnschten Betrag eingeben - max. "				  ;
	final String GELDNEHMEN="Nehmen Sie Ihr verdammtes Geld und verschwinden Sie!!!"		  ; 	
	final String KARTEIN="Karte einlegen"													  ;
	final String KARTENENTNAHME="Karte ist entriegelt - bitte entnehmen!"					  ;
	final String KARTENLOCK ="Karte ist eingelegt und verriegelt"							  ;
	final String KARTEOUT="Karte entnehmen"													  ;
	final String KARTENSLOTLOCK="Kartenslot verriegelt"										  ;    
	final String PININ="Bitte geben Sie Ihren PIN ein!"										  ;	
	final String SCHACHTLEER = "Kartenschacht leer"											  ;
	final String TOPSECRETPIN="0815"														  ;
	final String WAEHRUNG=""																  ;
	final String WILLKOMMENSNACHRICHT="Willkommen bei der Kredithaibank - wir nehmen Sie aus!";
	final String WUNSCHABBRUCH="Vorgang wunschgem abgebrochen"							  ;
	
	// diverse Limits initialisieren -> knnen je nach Wirtschaftslage gendert werden
	
	final int MAXBETRAG    = 2500;
	final int MAXFALSCHPIN =    3; // nach 3x falschem PIN Karte einziehen
	final int MAXSTELLEN   =    4;
 
   // erforderliche Variablen deklarieren
	
	private String Geld             = "";
	private String PIN              = "";
	private String Ziffer           = "";

	private int    PINFALSCHCOUNTER =  0;

	private BankomatView theView;
	private BankomatState theState;
	
	public void setView(BankomatView view) {
		theView = view;
		theState = LEER;
	}
	
	public void pressButtonDigit(int digit) {
		// TODO Auto-generated method stub
		// theView.setText("Digit " + digit + " pressed.");
	
		// je nach Status des Bankomaten reagieren und
		
		switch (theState) {
		
		// bei PIN-Eingabe die Sterne entsprechend der Stelle setzen und den dahinterstehenden PIN-Wert speichern und sammeln
		
		case PIN1:
			theView.setText		 ("*");
			PIN+=String.valueOf(digit);
			theState=			  PIN2;
			break					  ;
		case PIN2:					  
			theView.setText		("**");
			PIN+=String.valueOf(digit);
			theState=		      PIN3;
			break					  ;
		case PIN3:
			theView.setText(	"***");
			PIN+=String.valueOf(digit);
			theState=			  PIN4;
			break					  ;
		case PIN4:
			theView.setText	  ("****");
			PIN+=String.valueOf(digit);
			theState=		   PINENDE;
			break					  ;

		// bei Geldeingabe auf max. Stellen prfen, den Betrag ziffernweise sammeln und allenfalls bei berschreitung des Maximalbetrages letzte Stelle abschneiden

		case EINGABE_GELDBETRAG:

			if (Geld.length()<MAXSTELLEN) 		  		// max 4-stelligen Betrag zulassen (=2500 Euro)
			   {
			   Geld+=String.valueOf(digit)			  ; // Geldstring aufbereiten (Stellen sammeln)
			   }
			else
			   {
			   break				 				  ; // 5. Stelle gar nicht erst zulassen
			   }
			
			if (Integer.parseInt(Geld) > MAXBETRAG)     // ergibt 4-stelliger Geldbetrag mit 4. Stelle allerdings mehr als 2500 Euro?
			   {	
			   Geld=Geld.substring(0, Geld.length()-1); // ja, dann letzte Stelle wieder abschneiden
			   }
			
			theView.setText(Geld)					  ; // so erhaltenen akt. Geldbetrag am Display ausgeben 
			
			break									  ;
		default:
			break									  ;
		}
	}

	private void Setwunschabbruchkartenstate()
	{
    theView.setText(WUNSCHABBRUCH)       ;	
    theView.setKartenText(KARTENENTNAHME);
	theState=CANCEL_KARTE_HALB_DRAUSSEN  ;
	}
	
	// benutzerdefinierter Abbruchhanlder aus diversen States schmeit immer die Karte raus und wartet dann, dass sie Kunde entnimmt
	// -> obige Methode zur Vereinfachung...
	// Sinn bei PIN und Geldbetrag
	
	public void pressButtonCancel() {
		
		// je nach Status des Bankomaten reagieren
		
		switch (theState) {
		case PIN1:
			Setwunschabbruchkartenstate(); // da immer die drei gleichen Zuweisungen, dies in einer Methode machen, damit Sourcecode krzer
			break;
		case PIN2:
			Setwunschabbruchkartenstate(); // da immer die drei gleichen Zuweisungen, dies in einer Methode machen, damit Sourcecode krzer			
			break;
		case PIN3:
			Setwunschabbruchkartenstate(); // da immer die drei gleichen Zuweisungen, dies in einer Methode machen, damit Sourcecode krzer			
			break					     ;
		case PIN4:
			Setwunschabbruchkartenstate(); // da immer die drei gleichen Zuweisungen, dies in einer Methode machen, damit Sourcecode krzer			
			break					     ;
		case PINENDE:
			Setwunschabbruchkartenstate(); // da immer die drei gleichen Zuweisungen, dies in einer Methode machen, damit Sourcecode krzer			
			break					     ;
		case EINGABE_GELDBETRAG:
			Setwunschabbruchkartenstate(); // da immer die drei gleichen Zuweisungen, dies in einer Methode machen, damit Sourcecode krzer			
			break					     ;
		default:
			break						 ;
		}
	}
	
	// Lschtastenhandler (Sinn bei PIN und Gelbetrag):
	
	public void pressButtonDelete() {
		
		// je nach Status des Bankomaten reagieren auf
		
		switch (theState) {

		// PIN-States
		
		case PIN1:
			theView.setText					(PININ); // Defaulttext zur PIN-Eingabe
			if (PIN.length()>0)                      // erwartet PIN-Zeichen 1 -> Defaulttext ist da -> DEL wrde auf Out of Bound-Exception schneiden -> Abfangen
				PIN=PIN.substring(0,PIN.length()-1); // -> mit Check verhindert, d.h. jetzt ist es gefahrlos mglich, den PIN auf leer zu schneiden 
//			theState=PIN1						   ; // State bleibt...         
			break;
		case PIN2:
			theView.setText                 (PININ); // erwartet PIN-Zeichen 2 -> 1 ist da -> DEL schneidet auf Leer (=Defaulttext zur PIN-Eingabe) 
			PIN=PIN.substring    (0,PIN.length()-1); // PIN auf 0 Zeichen zurckschneiden
			theState=						   PIN1; // zurck auf PIN-Status 1
			break;
		case PIN3:
			theView.setText					  ("*"); // erwartet PIN-Zeichen 3 -> 2 sind da -> DEL schneidet auf 1 Stern zurck
			PIN=PIN.substring	 (0,PIN.length()-1); // PIN auf 1 Zeichen zurckschneiden
			theState=						   PIN2; // zurck auf PIN-Status 2
			break;
		case PIN4:
			theView.setText		 		     ("**"); // erwartet PIN-Zeichen 4 -> 3 sind da -> DEL schneidet auf 2 Sterne zurck
			PIN=PIN.substring    (0,PIN.length()-1); // PIN auch auf 2 Zeichen zurckschneiden
			theState=						   PIN3; // zurck auf PIN-Status 3
			break;
		case PINENDE:
			theView.setText					("***"); // erwartet ENTER-Besttigung, dass 4-zeichiger PIN ok -> DEL schneidet auf 3 Sterne zurck
			PIN=PIN.substring    (0,PIN.length()-1); // PIN auch auf 3 Zeichen zurckschneiden
			theState=						   PIN4; // zurck auf PIN-Status 4
			break								   ;

		// Geldbetraghandler
		
		case EINGABE_GELDBETRAG:

			if (Geld.length()>0) 					    												 // nur wenn ein Geldbetrag von mind. 1 Zeichen da ist, kann etwas ohne Out of Bound-Exception gelscht werden 
			   Geld=Geld.substring													(0,Geld.length()-1); // letztes Zeichen entsprechend abschneiden
			if (Geld.length()==0)																	     // wurde auf 0-Lnge geschnitten?
				theView.setText(GELDEINGABETEXT+String.valueOf(MAXBETRAG)+" "+String.valueOf(WAEHRUNG)); // -> ja, dann Standardtext zur Geldeingabe anzeigen
			else
			    theView.setText																	 (Geld); // nein -> jeweiligen akt. Geldbetrag am Display anzeigen lassen 
			break																					   ;
		default:
			break																					   ;
		}
	}

	// Eingabe-Handler (Sinn bei PIN und Geldbetrag)
	
	public void pressButtonEnter() {
		
		// je nach Status des Bankomaten reagieren
		
		switch (theState) {
		
		case EINGABE_GELDBETRAG:

			if ( (Geld.length()==0) || (Geld.length()<2) ) 	 											     // Geldbetrag muss zumindest 2 Zeichen lang sein, da Bankomaten mind. 10 Euro ausgeben 
			   break																					   ; // wenn nicht, wird weitergemacht und der State bleibt auf Geldeingabe... 
			
			Ziffer = Geld.substring											(Geld.length()-1,Geld.length()); // zwecks Vergleich die letzte Ziffer holen			

			if (!Ziffer.equals("0")) 																		 // diese muss immer 0 sein, da keine 5er-Scheine und Mnzen ausgegeben werden von Bankomaten
			   {
			   Geld=Geld.substring(0, Geld.length()-1)  												   ; // war sie es nicht, dann letzte Stelle wieder abschneiden
 			   if (Geld.length()==0) 																		 // wurde Geldbetrag nun aber auf 0-Lnge gestutzt?
 					theView.setText(GELDEINGABETEXT+String.valueOf(MAXBETRAG)+" "+String.valueOf(WAEHRUNG)); // dann wieder die Geldeingabemeldung anzeigen
 			   else
 				   theView.setText																	 (Geld); // anderenfalls den akt. Geldbetrag am Display ausgeben
 			   break																					   ; // State bleibt - weiter wird der Kunde erst gelassen, wenn der Betrag korrekt ist
			   }

			theView.setText										  ("Bitte entnehmen Sie zuerst Ihre Karte"); // an dieser Stell ist der Betrag korrekt -> Kunde auffordern seine Karte zu entnehmen, damit er nicht das Geld nimmt und die Karte vergisst
			theView.setKartenText														   (KARTENENTNAHME); // Kartenentnaheknopf entsprechend beschriften
			theState=																	KARTE_HALB_DRAUSSEN; // Status auf regulr Karte draussen setzen
			
			break																						   ;

		// PIN-Eingabenhandler
		
		case PINENDE:
			
			if (!PIN.equals(TOPSECRETPIN)) 																	 // stimmt der Pin nicht?
			   { 
			   PINFALSCHCOUNTER++																		   ; // dann den Zhler fr die falsche PIN-Eingabe erhhen
			   if (PINFALSCHCOUNTER==MAXFALSCHPIN) 														     // prfen, ob der Kunde schon zu oft zu bld war, den Code richtig einzutippen
			       {
				    theView.setText("PIN "+String.valueOf(MAXFALSCHPIN)+"x falsch. Karte wird eingezogen!"); // beim 3. Mal den Kunden bestrafen und die Karte einziehen

				    theView.setKartenButtonLabel												  (KARTEIN); // noramle Karteneingabemeldung auf den Knopf schreiben
					theView.setGeldladeText															   (""); // Geldlade initialisieren

// geht einen Scheidreck die Sleep-Meldung wegen der Karteneinzugsmeldung

/*					try
				    {
					Sleep(5000);
				    }
				    catch (InterruptedException e) {
				    }
					wait(5000); // nach 5 Sekunden wieder normale Meldung
*/				
				    // Anfangsinitialisierung, da Karte eingezogen ist und Platz fr neuen Kunden gemacht wird
				    
				    theView.setText													 (WILLKOMMENSNACHRICHT); // sonstige Werte auch auf Anfangsstatus setzen	
					theView.setKartenText													  (SCHACHTLEER);
				    theView.setKartenButtonLabel												  (KARTEIN);
					// theView.setGeldladeText("");	
				    Geld=																				 "";
				    PIN=																				 "";
				    PINFALSCHCOUNTER=																	  0;
				    theState																		  =LEER; // Status zrck an den Start (mit neuem Kunden)
				    break																		           ;
			       }   

			   PIN=																						 ""; // PIN frisch initialisieren
			   theView.setText																		(PININ); // PIN-Eingabemeldung anzeigen  
			   theState=																			   PIN1; // State wieder auf PIN1-Status (zurck an den PIN-Start)
			   break																					   ;
			   }			

			theView.setText(GELDEINGABETEXT+String.valueOf(MAXBETRAG)+" "+String.valueOf		(WAEHRUNG)); // PIN war korrekt an dieser Stelle
			Geld=																						 ""; // Geldbetrag initialisieren fr Eingabe
			theState=																	 EINGABE_GELDBETRAG; // State auf Eingabestatus dafr
			break;
		default:
			break																						   ;
		}
	}

	// Geldausgabehandler (macht nur Sinn, wenn Geld schon zur Entnahme vorhanden ist)

	public void pressButtonMoney() {
		
		// je nach Status des Bankomaten reagieren		

		switch (theState) {

		case GELDAUSGABE					     : // State prfen und Meldungen entsprechend setzen, da das Geld entnommen wurde
			theView.setText(WILLKOMMENSNACHRICHT);	
			theView.setKartenButtonLabel(KARTEIN);
			theView.setGeldladeText          ("");	
//			Geld=""								 ;
			PIN=""								 ;
			theState=						 LEER; // Geld ist entnommen -> Bankomat ist wieder im Anfangsstatus 
			break								 ;
		default:
			break								 ;
		}
	}

	// Kartenknopfhandler (macht nur Sinn, wenn Karte noch gar nicht in Verarbeitung / Verriegelung steckt, bzw. halb drauen ist zwecks Entnahmehandlungssimulation)
	
	public void pressButtonCard() {
		
		// je nach Status des Bankomaten reagieren
		
		switch (theState) {
		
		case LEER:										  // Karte wird eingesteckt und Meldungen entsprechend setzen, da Karte eingesteckt ist 
			theView.setText(PININ);
			theView.setKartenButtonLabel	  (KARTEOUT);
			theView.setKartenText		    (KARTENLOCK);
			theState							   =PIN1;
			break;
		case CANCEL_KARTE_HALB_DRAUSSEN:				  // Karte wird nach Benutzerabbruch entnommen und Meldungen entsprechend setzen, da keine Karte mehr drinnen ist
			theView.setText		  (WILLKOMMENSNACHRICHT);
			theView.setKartenButtonLabel       (KARTEIN);
			theView.setKartenText		   (SCHACHTLEER);
// 			Geld=								  	  ""; // Geldbetrag initialisieren */
 			PIN=								  	  ""; // PIN initialisieren			
			theState=								LEER; // Bankomat ohne Karte ist wieder in Anfangszustand
			break;
		case KARTE_HALB_DRAUSSEN:						  // Karte wird vor Geldausgabe entnommen (regulre Entnahme) und Meldungen entsprechend setzen, da Geldentnahme folgt
			theView.setGeldladeText				  (Geld); // Geldbetrag in Lade anzeigen
			theView.setText					(GELDNEHMEN);
			theView.setKartenButtonLabel(KARTENSLOTLOCK);
			theView.setKartenText		   (SCHACHTLEER);
			theState=						 GELDAUSGABE;
			break										;
	
		default:
			break									    ;
		}
	
	}
	
		
}	// end class
		
		
		
		
		

